// Simple demonstration on using an input device to trigger changes on your
// NeoPixels. Wire a momentary push button to connect from ground to a
// digital IO pin. When the button is pressed it will change to a new pixel
// animation. Initial state has all pixels off -- press the button once to
// start the first animation. As written, the button does not interrupt an
// animation in-progress, it works only when idle.

#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
 #include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif

// Digital IO pin connected to the button. This will be driven with a
// pull-up resistor so the switch pulls the pin to ground momentarily.
// On a high -> low transition the button press logic will execute.
#define BUTTON_PIN   1

#define PIXEL_PIN    1  // Digital IO pin connected to the NeoPixels.

#define PIXEL_COUNT 1  // Number of NeoPixels

#define POTPIN       1

#define POTPIN2       1

//
// hello.CMM-4030D-261-I2S-TR.ino
//
// CMM-4030D-261-I2S-TR I2C microphone hello-world
//    10 MHz clock, 24 bit samples, 115200 baud data
//
// Neil Gershenfeld 12/27/20
//
// This work may be reproduced, modified, distributed,
// performed, and displayed for any purpose, but must
// acknowledge this project. Copyright is retained and
// must be preserved. The work is provided as is; no
// warranty is provided, and users accept all liability.
//

#define nsamples 200
#define nstart 2000
#define SCK PIN1_bm
#define DS PIN0_bm
#define WS PIN3_bm
#define set(port,pin) (port |= pin)
#define clr(port,pin) (port &= (~pin))
#define sck_low clr(VPORTA.OUT,SCK);
#define sck_high set(VPORTA.OUT,SCK);
#define clock_delay tmp = VPORTA.IN;tmp = VPORTA.IN;tmp = VPORTA.IN;tmp = VPORTA.IN;
#define read_bit(byte_arg) byte_arg = (byte_arg<<1)+(VPORTB.IN&DS);tmp = VPORTA.IN;tmp = VPORTA.IN;tmp = VPORTA.IN;
// 2x(1+4) 100us instructions = 1 MHz bits = 1/(64+2) = 15 kHz samples

uint8_t tmp,sample,hibyte,midbyte,lobyte,hibytes[nsamples],midbytes[nsamples],lobytes[nsamples];
uint16_t count;

void setup() {
   
   }

void read_sample(uint8_t sample) {
   //
   // left channel, only one in use
   //
   sck_low;
   clock_delay;
   sck_high; // up 1
   clock_delay;
   sck_low; // down 1
   clock_delay;
   sck_high; // up 2
   read_bit(hibyte);
   sck_low; // down 2
   clock_delay;
   sck_high; // up 3
   read_bit(hibyte);
   sck_low; // down 3
   clock_delay;
   sck_high; // up 4
   read_bit(hibyte);
   sck_low; // down 4
   clock_delay;
   sck_high; // up 5
   read_bit(hibyte);
   sck_low; // down 5
   clock_delay;
   sck_high; // up 6
   read_bit(hibyte);
   sck_low; // down 6
   clock_delay;
   sck_high; // up 7
   read_bit(hibyte);
   sck_low; // down 7
   clock_delay;
   sck_high; // up 8
   read_bit(hibyte);
   sck_low; // down 8
   clock_delay;
   sck_high; // up 9
   read_bit(hibyte);
   sck_low; // down 9
   clock_delay;
   sck_high; // up 10
   read_bit(midbyte);
   sck_low; // down 10
   clock_delay;
   sck_high; // up 11
   read_bit(midbyte);
   sck_low; // down 11
   clock_delay;
   sck_high; // up 12
   read_bit(midbyte);
   sck_low; // down 12
   clock_delay;
   sck_high; // up 13
   read_bit(midbyte);
   sck_low; // down 13
   clock_delay;
   sck_high; // up 14
   read_bit(midbyte);
   sck_low; // down 14
   clock_delay;
   sck_high; // up 15
   read_bit(midbyte);
   sck_low; // down 15
   clock_delay;
   sck_high; // up 16
   read_bit(midbyte);
   sck_low; // down 16
   clock_delay;
   sck_high; // up 17
   read_bit(midbyte);
   sck_low; // down 17
   clock_delay;
   sck_high; // up 18
   read_bit(lobyte);
   sck_low; // down 18
   clock_delay;
   sck_high; // up 19
   read_bit(lobyte);
   sck_low; // down 19
   clock_delay;
   sck_high; // up 20
   read_bit(lobyte);
   sck_low; // down 20
   clock_delay;
   sck_high; // up 21
   read_bit(lobyte);
   sck_low; // down 21
   clock_delay;
   sck_high; // up 22
   read_bit(lobyte);
   sck_low; // down 22
   clock_delay;
   sck_high; // up 23
   read_bit(lobyte);
   sck_low; // down 23
   clock_delay;
   sck_high; // up 24
   read_bit(lobyte);
   sck_low; // down 24
   clock_delay;
   sck_high; // up 25
   read_bit(lobyte);
   sck_low; // down 25
   clock_delay;
   sck_high; // up 26
   read_bit(lobyte);
   sck_low; // down 26
   clock_delay;
   sck_high; // up 27
   clock_delay;
   sck_low; // down 27
   clock_delay;
   sck_high; // up 28
   clock_delay;
   sck_low; // down 28
   clock_delay;
   sck_high; // up 29
   clock_delay;
   sck_low; // down 29
   clock_delay;
   sck_high; // up 30
   clock_delay;
   sck_low; // down 30
   clock_delay;
   sck_high; // up 31
   clock_delay;
   sck_low; // down 31
   clock_delay;
   sck_high; // up 32
   clock_delay;
   sck_low; // down 32
   clock_delay;
   sck_high;
   
   //
   // right channel, not in use
   //

   sck_low;
   clock_delay;
   sck_high; // up 1
   clock_delay;
   sck_low; // down 1
   clock_delay;
   sck_high; // up 2
   clock_delay;
   sck_low; // down 2
   clock_delay;
   sck_high; // up 3
   clock_delay;
   sck_low; // down 3
   clock_delay;
   sck_high; // up 4
   clock_delay;
   sck_low; // down 4
   clock_delay;
   sck_high; // up 5
   clock_delay;
   sck_low; // down 5
   clock_delay;
   sck_high; // up 6
   clock_delay;
   sck_low; // down 6
   clock_delay;
   sck_high; // up 7
   clock_delay;
   sck_low; // down 7
   clock_delay;
   sck_high; // up 8
   clock_delay;
   sck_low; // down 8
   clock_delay;
   sck_high; // up 9
   clock_delay;
   sck_low; // down 9
   clock_delay;
   sck_high; // up 10
   clock_delay;
   sck_low; // down 10
   clock_delay;
   sck_high; // up 11
   clock_delay;
   sck_low; // down 11
   clock_delay;
   sck_high; // up 12
   clock_delay;
   sck_low; // down 12
   clock_delay;
   sck_high; // up 13
   clock_delay;
   sck_low; // down 13
   clock_delay;
   sck_high; // up 14
   clock_delay;
   sck_low; // down 14
   clock_delay;
   sck_high; // up 15
   clock_delay;
   sck_low; // down 15
   clock_delay;
   sck_high; // up 16
   clock_delay;
   sck_low; // down 16
   clock_delay;
   sck_high; // up 17
   clock_delay;
   sck_low; // down 17
   clock_delay;
   sck_high; // up 18
   clock_delay;
   sck_low; // down 18
   clock_delay;
   sck_high; // up 19
   clock_delay;
   sck_low; // down 19
   clock_delay;
   sck_high; // up 20
   clock_delay;
   sck_low; // down 20
   clock_delay;
   sck_high; // up 21
   clock_delay;
   sck_low; // down 21
   clock_delay;
   sck_high; // up 22
   clock_delay;
   sck_low; // down 22
   clock_delay;
   sck_high; // up 23
   clock_delay;
   sck_low; // down 23
   clock_delay;
   sck_high; // up 24
   clock_delay;
   sck_low; // down 24
   clock_delay;
   sck_high; // up 25
   clock_delay;
   sck_low; // down 25
   clock_delay;
   sck_high; // up 26
   clock_delay;
   sck_low; // down 26
   clock_delay;
   sck_high; // up 27
   clock_delay;
   sck_low; // down 27
   clock_delay;
   sck_high; // up 28
   clock_delay;
   sck_low; // down 28
   clock_delay;
   sck_high; // up 29
   clock_delay;
   sck_low; // down 29
   clock_delay;
   sck_high; // up 30
   clock_delay;
   sck_low; // down 30
   clock_delay;
   sck_high; // up 31
   clock_delay;
   sck_low; // down 31
   clock_delay;
   sck_high; // up 32
   clock_delay;
   
   hibytes[sample] = hibyte;
   midbytes[sample] = midbyte;
   lobytes[sample] = lobyte;
   }

void loop() {
   //
   // dummy reads for microphone to wake up and settle
   //
   for (count = 0; count < nstart; ++count)
      read_sample(0);
   //
   // read samples
   //
   for (sample = 0; sample < nsamples; ++sample)
      read_sample(sample);
   //
   // send framing
   //
   Serial.write(1);
   Serial.write(2);
   Serial.write(3);
   Serial.write(4);
   //
   // send samples
   //
   for (sample = 0; sample < nsamples; ++sample) {
      Serial.write(lobytes[sample]);
      Serial.write(midbytes[sample]);
      Serial.write(hibytes[sample]);
      }
   }


volatile bool interrupt;

// Declare our NeoPixel strip object:
Adafruit_NeoPixel strip(PIXEL_COUNT, PIXEL_PIN, NEO_GRB + NEO_KHZ800);
// Argument 1 = Number of pixels in NeoPixel strip
// Argument 2 = Arduino pin number (most are valid)
// Argument 3 = Pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
//   NEO_RGBW    Pixels are wired for RGBW bitstream (NeoPixel RGBW products)

int     mode     = 0;    // Currently-active animation mode, 0-9

void setup() {
  set(VPORTA.OUT,SCK);
  set(VPORTA.DIR,SCK);
  pinMode(BUTTON_PIN, INPUT_PULLUP);
  strip.begin(); // Initialize NeoPixel strip object (REQUIRED)
  strip.show();  // Initialize all pixels to 'off'
  attachInterrupt(digitalPinToInterrupt(BUTTON_PIN), intf, FALLING);
}

void loop() {
  interrupt = false;
  if(++mode > 4) mode = 0; // Advance to next mode, wrap around after #2
  switch(mode) {           // Start the new animation...
    case 0:
      colorWipe(strip.Color(  0,   0,   0), 50);    // Black/off
      break;
    case 1:
      colorWipe(strip.Color(255,   0,   0), 50);    // Red
      break;
    case 2:
      rainbow(10);
      break;
    case 3:
      VU();
      break;
    case 4:
      colorWipe(strip.Color(  255,   255,   255), 50); //white
      break;
  }
}

// Fill strip pixels one after another with a color. Strip is NOT cleared
// first; anything there will be covered pixel by pixel. Pass in color
// (as a single 'packed' 32-bit value, which you can get by calling
// strip.Color(red, green, blue) as shown in the loop() function above),
// and a delay time (in milliseconds) between pixels.
void colorWipe(uint32_t color, int wait) {
  while(!interrupt){  //while button isn't pressed
    
    for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
      strip.setBrightness(map(analogRead(POTPIN2), 0, 1023, 255, 0)); //set brightness from 0-255, depending on the 10-bit POTPIN value
      strip.setPixelColor(i, color);         //  Set pixel's color (in RAM)
      strip.show();                          //  Update strip to match
      delay(wait);                           //  Pause for a moment
    } 
  }
  
}

// Rainbow cycle along whole strip. Pass delay time (in ms) between frames.
void rainbow(int wait) {
  // Color wheel has a range of 65536 but it's OK if we roll over, so
  // just count from 0 to 3*65536. Adding 256 to firstPixelHue each time
  // means we'll make 3*65536/256 = 768 passes through this outer loop:
  while(!interrupt){
    for(long firstPixelHue = 0; firstPixelHue < 65536; firstPixelHue += 256) {
      strip.setBrightness(map(analogRead(POTPIN2), 0, 1023, 255, 0));
      wait = map(analogRead(POTPIN), 0, 1023, 50, 1);  //set animation speed from 100-1ms, depending on 10-bit POTPIN value
      for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
        // Offset pixel hue by an amount to make one full revolution of the
        // color wheel (range of 65536) along the length of the strip
        // (strip.numPixels() steps):
        int pixelHue = firstPixelHue + (i * 65536L / strip.numPixels());
        // strip.ColorHSV() can take 1 or 3 arguments: a hue (0 to 65535) or
        // optionally add saturation and value (brightness) (each 0 to 255).
        // Here we're using just the single-argument hue variant. The result
        // is passed through strip.gamma32() to provide 'truer' colors
        // before assigning to each pixel:
        strip.setPixelColor(i, strip.gamma32(strip.ColorHSV(pixelHue)));
      }
      strip.show(); // Update strip with new contents
      delay(wait);  // Pause for a moment
    }
  }
  
}

void VU(){
  while(!interrupt){
    for(long pixelHue = 0; pixelHue < 65536; pixelHue += 64) {
      strip.setBrightness(map(analogRead(POTPIN2), 0, 1023, 255, 0));
      int vol = map(analogRead(POTPIN), 0, 1023, 0, strip.numPixels());
      if (vol >= strip.numPixels()-1){
        for(int i=0; i<strip.numPixels(); i++) {
        strip.setPixelColor(i, strip.gamma32(strip.ColorHSV(pixelHue)));
        } 
      }
      else{
        for(int i=0; i<vol; i++) {
        strip.setPixelColor(i, strip.gamma32(strip.ColorHSV(pixelHue)));
        }
      
      
        for (int i=vol; i<strip.numPixels(); i++) {
          strip.setPixelColor(i, strip.Color(  0,   0,   0));
        }
      }
      strip.show();
      delay(10);
    }
    
  }
    
    
}

void intf() {
  interrupt = true; //Interrupt function, set interrupt flag to true
}
